<template>
  <div>
    <v-card :loading="isLoadingCumplimientoSeccionPorNivel">
      <IdGrafico id="008" />
      <div class="gris">
        <h2 class="tituloBloque">
          Cumplimiento por sección a nivel
          <span
            v-if="
              globalFilters &&
                globalFilters.filters.nivel_geografico.descripcion
            "
            class="bold keep-spaces"
            >{{
              " " + globalFilters.filters.nivel_geografico.descripcion
            }}</span
          >
        </h2>
        <div class="divCumplimiento7s">
          <template
            v-for="(itemCumplimientoSeccionNegocio,
            indexItemCumplimientoSeccionNegocio) in cumplimientoSeccionesNegocios"
          >
            <v-img
              :key="'img' + indexItemCumplimientoSeccionNegocio"
              :contain="true"
              :aspect-ratio="1"
              position="center"
              class="segundaSeccionImg"
              height="25"
              width="65"
              :src="itemCumplimientoSeccionNegocio.logo_image"
              :lazy-src="itemCumplimientoSeccionNegocio.logo_image"
            />
            <v-simple-table
              :key="indexItemCumplimientoSeccionNegocio"
              class="tblVue tblCumplimiento7s"
            >
              <template v-slot:default>
                <thead class="tblHead">
                  <tr>
                    <template
                      v-for="(itemModulo,
                      indexItemModulo) in itemCumplimientoSeccionNegocio
                        .cumplimiento_seccion.modulos"
                    >
                      <th :key="indexItemModulo" class="text-center">
                        {{ itemModulo.descripcion }} =
                        {{ itemModulo.valor_seccion }}
                      </th>
                    </template>
                  </tr>
                </thead>
                <tbody class="tblBody">
                  <tr>
                    <template
                      v-for="(itemCalificacion,
                      indexItemCalificacion) in itemCumplimientoSeccionNegocio
                        .cumplimiento_seccion.calificaciones"
                    >
                      <td :key="indexItemCalificacion" class="cantidad">
                        <div
                          class="circle"
                          :style="{
                            backgroundColor: itemCalificacion.rango.detalle
                          }"
                        ></div>
                        {{ itemCalificacion.puntos_obtenidos }}
                      </td>
                    </template>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </template>
        </div>
      </div>
    </v-card>
  </div>
</template>

<style scoped>
.gris {
  width: 100%;
  margin: 0px auto;
  padding: 15px 15px;
  background-color: #faf9f9;
  -moz-box-shadow: 0 0px 1px rgb(226, 222, 222);
  -webkit-box-shadow: 0 0px 1px rgb(226, 222, 222);
  box-shadow: 0 0px 1px rgb(226, 222, 222);
  margin-bottom: 15px;
  text-align: justify;
  height: 100%;
}
.tituloBloque {
  font-size: 18px;
  color: #000;
  padding-bottom: 15px;
  font-family: "Avenir_Next_Regular", sans-serif;
}
.bold {
  font-family: "Avenir_Next_Bold", sans-serif;
}
</style>
<style scoped>
.keep-spaces {
  white-space: pre-wrap;
}
.tblVue {
  width: 100%;
  background-color: #fcfcfc !important;
}
.tblVue .tblHead tr th {
  padding: 5px 10px 6px 10px;
  color: #333333 !important;
  text-align: center;
  font-weight: 100;
  border-bottom: 1px solid #3e3d3d !important;
  font-size: 14px;
  font-family: "Avenir_Next_Bold";
  min-width: 87px;
}
.tblVue .v-data-table__wrapper {
  overflow-x: hidden !important;
}
.tblVue .tblBody tr td {
  padding: 7px 10px 7px 10px;
  color: #606664;
  font-size: 13px;
  text-align: center;
  border-bottom: 1px solid #bebebe !important;
}
.tblVue .tblBody tr:last-of-type td {
  border-bottom: none !important;
}
.theme--light.v-data-table tbody tr:hover {
  background: #eeeeee !important;
}
.tblVue tbody tr td.cantidad {
  width: 120px;
  margin: auto;
  text-align: center;
  color: #000;
}
.tblVue tbody tr td .circle {
  width: 15px;
  height: 15px;
  border-radius: 100%;
  display: inline-block;
  margin-right: 5px;
}
.tblVue tbody tr td img {
  width: 65px;
}
.tblVue tr.total td {
  font-family: "Avenir_Next_Demi_Bold";
}
.divCumplimiento7s .tblVue {
  padding: 15px;
  box-sizing: border-box;
}
.puntajeAmarillo {
  background-color: #f3c75c;
}
.v-tab {
  text-transform: capitalize !important;
  font-weight: inherit !important;
  border-bottom: 2px solid #ffffff;
}
.v-tab:last-of-type {
  border-right: 0px;
}
.theme--light.v-tabs > .v-tabs-bar {
  background-color: #f2f2f2 !important;
}
.tabEstiloPrimario .v-tab--active {
  background-color: #fcfcfc;
  color: #000000 !important;
  font-weight: bold !important;
  box-shadow: -3px 5px 11px -5px rgba(153, 150, 153, 1);
}
.tabEstiloPrimario .v-tab--active:focus {
  background-color: transparent !important;
}
.tabEstiloSecundario .v-tab--active {
  background-color: transparent;
  color: rgba(0, 0, 0, 0.54) !important;
  font-weight: bold !important;
}
.tab .v-item-group .v-slide-group__wrapper .v-tabs-bar__content .v-tab--active {
  background-color: #ffffff !important;
  color: #ffffff !important;
  font-weight: bold !important;
}
.theme--light.v-tabs-items {
  background-color: transparent !important;
}
</style>
<script>
import store from "@/store";
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-CumplimientoSeccionPorNivel",
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  components: {
    IdGrafico
  },
  data() {
    return {
      isLoadingCumplimientoSeccionPorNivel: true,
      isPersentValue: true,
      methodsSemaforo: null,
      globalFilters: null,
      cumplimientoSeccionesNegocios: []
    };
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      this.globalFilters = globalFilters;
      this.getCumplimientoSeccionesNegocios();
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getCumplimientoSeccionesNegocios() {
      this.isLoadingCumplimientoSeccionPorNivel = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/seccion/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoSeccionesNegocios(data);
              }
            } else {
              self.setCumplimientoSeccionesNegocios([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoSeccionPorNivel = false;
        });
    },
    setCumplimientoSeccionesNegocios(cumplimientoSeccionesNegocios) {
      cumplimientoSeccionesNegocios.forEach((itemSeccionNegocio) => {
        itemSeccionNegocio.logo_image = serviceCommons.getLogoImageByIdNegocio(
          itemSeccionNegocio.id_negocio
        );
        itemSeccionNegocio.cumplimiento_seccion.calificaciones.forEach(
          (itemCalificacion) => {
            if (
              this.methodsSemaforo &&
              this.methodsSemaforo.getRangoByLimit(
                itemCalificacion.calificacion
              )
            ) {
              let rango = this.methodsSemaforo.getRangoByLimit(
                itemCalificacion.calificacion
              );
              itemCalificacion.rango = {
                detalle: rango.detalle
              };
            } else {
              itemCalificacion.rango = {
                detalle: ""
              };
            }
          }
        );
      });
      this.cumplimientoSeccionesNegocios = cumplimientoSeccionesNegocios;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters && this.methodsSemaforo) {
      this.getCumplimientoSeccionesNegocios();
    }
  }
};
</script>
